# Loop this first to prevent wrong ordering
team empty forget

# Tick abilities
execute as @a at @s store result score @s ab.covering_blocks if blocks ~ ~0.5 ~ ~ 319 ~ ~ ~0.5 ~ masked
execute as @a[tag=abilities.ghost] run function abilities:ghost
execute as @a[tag=abilities.blaze] run function abilities:blaze
execute as @a[tag=abilities.miner] run function abilities:miner
execute as @a[tag=abilities.explorer] run function abilities:explorer
execute as @a[tag=abilities.warden] run function abilities:warden
execute as @a[tag=abilities.glass_golem] unless score #noglass ab.config matches 1 run function abilities:glass
execute as @a[tag=abilities.shadow] run function abilities:shadow
execute as @a[tag=abilities.avian] run function abilities:avian
execute as @a[tag=abilities.shulker] run function abilities:shulker
execute as @a[tag=abilities.elytrian] run function abilities:elytrian
execute as @a[tag=abilities.lightning] run function abilities:lightning
execute as @a[tag=abilities.fish] run function abilities:fish
execute as @a[tag=abilities.iron_golem] run function abilities:iron_golem
execute as @a[tag=abilities.creeper] unless score #nocreeper ab.config matches 1 run function abilities:creeper
execute as @a[tag=abilities.darkness] run function abilities:darkness
execute as @a[tag=abilities.guardian] run function abilities:guardian
execute as @a[tag=abilities.enderian] run function abilities:enderian

# Tick selection
scoreboard players enable @a select
scoreboard players enable @a showMenu
execute as @a[scores={showMenu=1}] unless score #disableMenu ab.config matches 1 run function abilities:selection_menu
execute as @a[scores={select=1},tag=!ab.selected] run tag @s add abilities.ghost
execute as @a[scores={select=2},tag=!ab.selected] run tag @s add abilities.shadow
execute as @a[scores={select=3},tag=!ab.selected] run tag @s add abilities.blaze
execute as @a[scores={select=4},tag=!ab.selected] run tag @s add abilities.miner
execute as @a[scores={select=5},tag=!ab.selected] run tag @s add abilities.explorer
execute as @a[scores={select=6},tag=!ab.selected] run tag @s add abilities.warden
execute as @a[scores={select=7},tag=!ab.selected] unless score #noglass ab.config matches 1 run tag @s add abilities.glass_golem
execute as @a[scores={select=8},tag=!ab.selected] run tag @s add abilities.avian
execute as @a[scores={select=9},tag=!ab.selected] run tag @s add abilities.shulker
execute as @a[scores={select=10},tag=!ab.selected] run tag @s add abilities.elytrian
execute as @a[scores={select=11},tag=!ab.selected] run tag @s add abilities.lightning
execute as @a[scores={select=12},tag=!ab.selected] run tag @s add abilities.fish
execute as @a[scores={select=13},tag=!ab.selected] run tag @s add abilities.iron_golem
execute as @a[scores={select=14},tag=!ab.selected] unless score #nocreeper ab.config matches 1 run tag @s add abilities.creeper
execute as @a[scores={select=15},tag=!ab.selected] run tag @s add abilities.darkness
execute as @a[scores={select=16},tag=!ab.selected] run tag @s add abilities.guardian
execute as @a[scores={select=17},tag=!ab.selected] run tag @s add abilities.enderian
execute as @a[scores={select=17},tag=!ab.selected] run give @s ender_pearl



execute as @a[scores={select=1..}] run tag @s add ab.selected
execute as @a[scores={select=1..}] run tellraw @s ["",{"text":"Selection complete!","color":"green"},{"text":"\nPlease note that you cannot change abilities now! If you need to change, ask the server operator","color":"gold"}]
execute as @a[scores={select=1..}] run trigger select set -1

# Select menu
execute as @a[scores={select=0},tag=!ab.seenMenu] unless score #disableMenu ab.config matches 1 run function abilities:selection_menu

# Prevent fireballs from starting fires
execute as @e[tag=ab.fireball] unless block ~ ~-0.5 ~ air run kill @s

# Handle powers and cooldowns
scoreboard players add @a timer 1
execute as @a if score @s timer matches 20.. if predicate abilities:is_sneaking_and_jumping unless predicate abilities:is_in_water run function abilities:powers/handle_short_powers
function abilities:powers/handle_tick

# Tick special
scoreboard players set @a[tag=!abilities.fish] air 300
execute as @a[tag=abilities.enderian,scores={hasDied=1..},nbt={Health:20.0f}] run give @s ender_pearl
execute as @a[scores={hasDied=1..},nbt={Health:20.0f}] run scoreboard players set @s hasDied 0

